import { world, system, BlockPermutation} from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe(initEvent => {
const blocks = [
    "uexp:thorns_trap"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("uexp:step_on", {
    onStepOn: eventData => {
    const entity = eventData.entity;
    const block = eventData.block;
    const {x, y, z} = block.location;
    if (blocks.includes(block.typeId)) {
      if (!entity.isSneaking && entity.hasComponent('minecraft:type_family')) {
        if (block.typeId === "uexp:thorns_trap" && block.permutation.getState( "uexp:pressed" ) == 0) {
          system.run(() => {
            entity.applyDamage(9);
            entity.runCommandAsync(`setblock ${x} ${y} ${z} uexp:thorns_trap ["uexp:pressed"=1]`);
            entity.runCommandAsync(`execute if block ${x-1} ${y-1} ${z} unpowered_repeater run setblock ${x-1} ${y-1} ${z} powered_repeater ["minecraft:cardinal_direction"="east","repeater_delay"=3]`);
            entity.runCommandAsync(`execute if block ${x+1} ${y-1} ${z} unpowered_repeater run setblock ${x+1} ${y-1} ${z} powered_repeater ["minecraft:cardinal_direction"="west","repeater_delay"=3]`);
            entity.runCommandAsync(`execute if block ${x} ${y-1} ${z+1} unpowered_repeater run setblock ${x} ${y-1} ${z+1} powered_repeater ["minecraft:cardinal_direction"="north","repeater_delay"=3]`);
            entity.runCommandAsync(`execute if block ${x} ${y-1} ${z-1} unpowered_repeater run setblock ${x} ${y-1} ${z-1} powered_repeater ["minecraft:cardinal_direction"="south","repeater_delay"=3]`);
            })
          }
        }
      }
    }
  })
})