import { world, system, BlockPermutation, ItemStack, Player } from '@minecraft/server';
import { decrement_stack, use_durability} from '../functions';

world.beforeEvents.itemUseOn.subscribe((data) => {
    const player = data.source;
    const block = data.block;
    const item = data.itemStack;
    const { x, y, z } = block.location;
    const block_below = block.below();
    const fertilizer = ["minecraft:bone_meal"]
    const place_filter_arid = [
        "minecraft:sand","minecraft:dirt","minecraft:suspicious_sand","minecraft:hardened_clay","minecraft:red_terracotta","minecraft:blue_terracotta","minecraft:yellow_terracotta","minecraft:green_terracotta","minecraft:lime_terracotta","minecraft:orange_terracotta","minecraft:blue_terracotta","minecraft:light_blue_terracotta","minecraft:light_gray_terracotta","minecraft:gray_terracotta","minecraft:white_terracotta","minecraft:black_terracotta","minecraft:brown_terracotta","minecraft:cyan_terracotta","minecraft:pink_terracotta","minecraft:purple_terracotta"
    ]
    const crop_arid = [
        "uexp:frades_crown_fruit"
    ]
    
    if(block.hasTag("uexp_crop_phase_0") && fertilizer.includes(item.typeId)) {
     const getItem = item.typeId
        system.runTimeout(() =>{
            player.runCommand("playsound item.bone_meal.use @a[r=7]");
            player.runCommand(`particle minecraft:crop_growth_emitter ${x} ${y} ${z}`);
            player.runCommand(`execute if block ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="east","uexp:growth_phase"=0] run setblock ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="east","uexp:growth_phase"=1]`);
            player.runCommand(`execute if block ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="north","uexp:growth_phase"=0] run setblock ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="north","uexp:growth_phase"=1]`);
            player.runCommand(`execute if block ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="west","uexp:growth_phase"=0] run setblock ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="west","uexp:growth_phase"=1]`);
            player.runCommand(`execute if block ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="south","uexp:growth_phase"=0] run setblock ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="south","uexp:growth_phase"=1]`);
        }, 1)
    }
    if(block.hasTag("uexp_crop_phase_1") && fertilizer.includes(item.typeId)) {
     const getItem = item.typeId
        system.runTimeout(() =>{
            player.runCommand("playsound item.bone_meal.use @a[r=7]");
            player.runCommand(`particle minecraft:crop_growth_emitter ${x} ${y} ${z}`);
            player.runCommand(`execute if block ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="east","uexp:growth_phase"=1] run setblock ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="east","uexp:growth_phase"=2]`);
            player.runCommand(`execute if block ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="north","uexp:growth_phase"=1] run setblock ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="north","uexp:growth_phase"=2]`);
            player.runCommand(`execute if block ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="west","uexp:growth_phase"=1] run setblock ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="west","uexp:growth_phase"=2]`);
            player.runCommand(`execute if block ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="south","uexp:growth_phase"=1] run setblock ${x} ${y} ${z} uexp:frades_crown ["minecraft:cardinal_direction"="south","uexp:growth_phase"=2]`);
        }, 1)
    }
    if(place_filter_arid.includes(block.typeId) && crop_arid.includes(item.typeId)) {
     const getItem = item.typeId
        system.runTimeout(() =>{
            player.runCommand(`execute if entity @s[hasitem={item=uexp:frades_crown_fruit,location=slot.weapon.mainhand}] run setblock ${x} ${y+1} ${z} uexp:frades_crown`);
            player.runCommand(`clear @s ${getItem} 0 1`);
        }, 1)
    }
})