import { world, system, GameMode } from "@minecraft/server";

world.afterEvents.itemUse.subscribe(eventData => {
  const player = eventData.source;
  const itemUsed = eventData.itemStack;
  const playerEquippable = player.getComponent("equippable");
  const ListItemUse = [
    "uexp:putrid_staff",
    "uexp:scepter_of_return",
    "uexp:boitata_eye",
    "uexp:rapine_glove"
  ]
        
  function useDurability () {
    if (!player.matches({ gameMode: GameMode.creative })) {
      const itemEnchantable = itemUsed.getComponent("minecraft:enchantable");
      const unbreakingLevel = itemEnchantable?.getEnchantment("unbreaking")?.level ?? 0;
      const breakChance = 100 / (unbreakingLevel + 1);
      const randomizeChance = Math.random() * 100;
      if (breakChance < randomizeChance) return;
      const itemDurability = itemUsed.getComponent("durability");
      if (!itemDurability) return;
      const itemMaxDurability = itemDurability.maxDurability;
      const itemDurabilityDamage = itemDurability.damage;
      const durabilityCalculation = itemMaxDurability - itemDurabilityDamage;
      let damageAmount = 1;
      const currentDurability = durabilityCalculation - damageAmount;
      if (currentDurability <= 0) {
        player.playSound("random.break", { pitch: 0.9, location: player.location, volume: 1 });
        playerEquippable.setEquipment("Mainhand", null);
      }
      else {
        itemDurability.damage += damageAmount;
        playerEquippable.setEquipment("Mainhand", itemUsed)
      }
    }
  }

  if (itemUsed === undefined) return;
  if (ListItemUse.includes(itemUsed.typeId)){
    if (itemUsed.typeId === "uexp:putrid_staff") {
      const cooldown = itemUsed.getComponent("cooldown").getCooldownTicksRemaining(player);
      if (cooldown == 47) {
        player.runCommandAsync("tag @e[type=!player,r=7] add uexpFlyAttack");
        player.runCommandAsync("tag @s add uexpNoFlyAttack");
        player.runCommandAsync("summon uexp:belfly ~~1~");
        player.runCommandAsync("summon uexp:belfly ~~1~");
        player.runCommandAsync("summon uexp:belfly ~~1~");
        player.runCommandAsync("summon uexp:belfly ~~1~");
        player.runCommandAsync("summon uexp:belfly ~~1~");
        player.runCommandAsync("summon uexp:belfly ~~1~");
        player.runCommandAsync("summon uexp:belfly ~~1~");
        useDurability();
      }
    }
    if (itemUsed.typeId === "uexp:scepter_of_return") {
      const cooldown = itemUsed.getComponent("cooldown").getCooldownTicksRemaining(player);
      if (cooldown == 47) {
        const playerName = player.name
        if (player.isSneaking) {     
          player.runCommandAsync(`tp @s @e[name="${playerName}", c=1, type=!player]`);
          useDurability();
        }
        else {
          player.runCommandAsync(`tp @e[name="${playerName}", c=1, type=!player] @s`);
          useDurability();
        }
      }
    }
    if (itemUsed.typeId === "uexp:boitata_eye"){
     const cooldown = itemUsed.getComponent("cooldown").getCooldownTicksRemaining(player);
      if (cooldown == 47) {
        player.runCommandAsync("tag @s add uexpBoitataEye");
        player.runCommandAsync("execute at @e[tag=!uexpBoitataEye,r=16] run summon uexp:heat_trail");
        useDurability();
      }
    }
    if (itemUsed.typeId === "uexp:rapine_glove"){
      const cooldown = itemUsed.getComponent("cooldown").getCooldownTicksRemaining(player);
       if (cooldown == 47) {
         player.runCommandAsync("tag @s add uexpRapineGlove");
         player.runCommandAsync("damage @e[tag=!uexpRapineGlove,type=!item,r=7] 4 contact");
         useDurability();
       }
     }
  }
})
