import { world, system, GameMode } from '@minecraft/server';

world.beforeEvents.itemUseOn.subscribe((data) => {
    const player = data.source;
    const playerEquippable = player.getComponent("equippable");
    const block = data.block;
    const {x, y, z} = block.location;
    const item = data.itemStack;
    const block_below = block.below();
    const ListItemUse = [
        "uexp:jar_with_gold_drop_frog",
        "uexp:jar_with_blue_poison_dart_frog",
        "uexp:jar_with_firefly",
        "uexp:bucket_with_electric_fish",
        "uexp:bucket_with_piranha",
        "uexp:ammofago_jaw"
    ]
    function useDurability () {
        if (!player.matches({ gameMode: GameMode.creative })) {
            const itemEnchantable = item.getComponent("minecraft:enchantable");
            const unbreakingLevel = itemEnchantable?.getEnchantment("unbreaking")?.level ?? 0;
            const breakChance = 100 / (unbreakingLevel + 1);
            const randomizeChance = Math.random() * 100;
            if (breakChance < randomizeChance) return;
            const itemDurability = item.getComponent("durability");
            if (!itemDurability) return;
            const itemMaxDurability = itemDurability.maxDurability;
            const itemDurabilityDamage = itemDurability.damage;
            const durabilityCalculation = itemMaxDurability - itemDurabilityDamage;
            let damageAmount = 1;
            const currentDurability = durabilityCalculation - damageAmount;
            if (currentDurability <= 0) {
            player.playSound("random.break", { pitch: 0.9, location: player.location, volume: 1 });
            playerEquippable.setEquipment("Mainhand", null);
        }
        else {
            itemDurability.damage += damageAmount;
            playerEquippable.setEquipment("Mainhand", item)
        }
    }
}
    if (ListItemUse.includes(item.typeId)){
        if((item.typeId == "uexp:jar_with_gold_drop_frog" || item.typeId == "uexp:jar_with_blue_poison_dart_frog" || item.typeId == "uexp:jar_with_firefly")) {
            system.runTimeout(() =>{
                player.runCommand("replaceitem entity @s slot.weapon.mainhand 0 uexp:jar_of_catch 1");
            }, 1)
        }
        if((item.typeId == "uexp:bucket_with_electric_fish" || item.typeId == "uexp:bucket_with_piranha")) {
            system.runTimeout(() =>{
                player.runCommand("replaceitem entity @s slot.weapon.mainhand 0 water_bucket");
            }, 1)
        }
        if (item.typeId == "uexp:ammofago_jaw"){
            system.runTimeout(() =>{
                player.runCommandAsync(`execute unless block ${x} ${y-1} ${z} bedrock unless block ${x} ${y-1} ${z} reinforced_deepslate unless block ${x} ${y-1} ${z} border_block unless block ${x} ${y-1} ${z} barrier run fill ${x-1} ${y-1} ${z-1} ${x+1} ${y+1} ${z+1} air destroy`);
                useDurability();
            }, 1)
        }
    }
})